//  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//  N o t e b o o k   H a r d w a r e   C o n t r o l   A C P I   D L L
//  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//  Suits ASUS Z99H (A8JS mainboard)
//  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//  Written by: nullpointer@mail.ru, last updated: 4:42 25.02.2007, ABSOLUTELY NO WARRANTIES! USE AT OWN RISK!
//  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

public static class ASUSTeK
{
	#region Notebook Asus A8JS : class A8JS
	public static class A8JS
	{
		#region Class for Asus A8JS FAN control : class FAN
		public static class FAN
		{
			public const string description = "ACPI fan manual control";
			public const bool default_enable = false;
			public const int icon = 2;
			
			public static class FAN_ON_OFF
			{
				public const string description = "Current fan state (on\\off)";
				public const bool nhc_visible = true;
				public static int fan_on_off = 0;
				public const string unit = "off|on";
				
				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 1;
					public const int nhc_default_value = 1;
					public static bool initialisation = false;

					public static bool nhc_on_write()
					{
						if(!initialisation)
						{
							int a = 0;
							ACPI.NAME.Read("_TZ.PLCY", ref a);
							FAN_ON_OFF.fan_on_off = ((a == 0)? 1: 0);
							initialisation = true;
							return true;
						}						
						if(fan_on_off != 0)
						{
							ACPI.NAME.Write("_TZ.PLCY", 0);
							int a, b, c, res;
							a = 0x84;
							b = FAN_SPEED.fan_speed;
							c = 0xC4;
							res = ((a << 16) + (b << 8) + (c));
							ACPI.METHOD.SetValue("_TZ.TMSS", 0);
							ACPI.METHOD.SetValue("_SB.ATKD.ECRW", res);
							ACPI.METHOD.Call("_TZ.UMIT");
						}
						else
						{
							ACPI.NAME.Write("_TZ.PLCY", 1);
							ACPI.METHOD.Call("_TZ.TCHG");	
						}
						return true;
					}
				}
			}
			public static class FAN_SPEED
			{
				public const string description = "Current fan speed (0 to 255)";
				public const bool nhc_visible = true;
				public static int fan_speed = 0;
				public const string unit = "";				
				
				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 255;
					public const int nhc_default_value = 144;
					public static bool initialisation = false;

					public static bool nhc_on_write()
					{
						if(!initialisation)
						{
							int a = 0;
							ACPI.FIELD.Read("_SB.PCI0.SBRG.EC0.CDT1", ref a);
							FAN_SPEED.fan_speed = a;
							initialisation = true;
							return true;
						}
						int is_fan_off = 0;						       						        
						ACPI.NAME.Read("_TZ.PLCY", ref is_fan_off);
						if(is_fan_off == 0)
						{
							int a, b, c, res;
							a = 0x84;
							b = fan_speed;
							c = 0xC4;
							res = ((a << 16) + (b << 8) + (c));
							ACPI.METHOD.SetValue("_TZ.TMSS", 0);
							ACPI.METHOD.SetValue("_SB.ATKD.ECRW", res);
							ACPI.METHOD.Call("_TZ.UMIT");							        
						}
						return true;
					}
				}
			}
		}
		#endregion

		#region Class for Asus A8JS QFAN control : class QFAN
		public static class QFAN
		{
			public const string description = "ACPI fan automatic temperature control";
			public const bool default_enable = false;
			public const int icon = 2;
			
			#region Value class for QFAN_CPUTemperature : class QFAN_CPUTemperature
			public static class QFAN_CPUTemperature
			{
				public const string description = "Current CPU temperature";
				public const bool nhc_visible = true;
				public static int qfan_cputemperature = 0;
				public const string unit = "C";
			}
			#endregion

			#region Value class for QFAN_FanSpeed : class QFAN_FanSpeed
			public static class QFAN_FanSpeed
			{
				public const string description = "Current fan speed (0 - 255)";
				public const bool nhc_visible = true;
				public static int qfan_fanspeed = 0;
				public const string unit = "";
			}
			#endregion
			
			#region Value class for QFAN_CPUTemperaturePrevious : class QFAN_CPUTemperaturePrevious
			public static class QFAN_CPUTemperaturePrevious
			{
				public const string description = "";
				public const bool nhc_visible = false;
				public static int qfan_cputemperatureprevious = -1;
				public const string unit = "";
				public static int qfan_refreshdivider = 0;
			}
			#endregion		

			#region Value class for QFAN_CPUTemperatureDesired : class QFAN_CPUTemperatureDesired
			public static class QFAN_CPUTemperatureDesired
			{
				public const string description = "Desired CPU temperature";
				public const bool nhc_visible = true;
				public static int qfan_cputemperaturedesired = 0;
				public const string unit = "C";				

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 80;
					public const int nhc_default_value = 45;
					public static bool initialisation = false;

					public static bool nhc_on_write()
					{
						if(!initialisation)
						{
							int a = 0;
							ACPI.FIELD.Read("_TZ.THRM._TMP", ref a);
	   						a = (a - 2732) / 10;
	   						QFAN_CPUTemperature.qfan_cputemperature = a;
							QFAN_CPUTemperaturePrevious.qfan_cputemperatureprevious = a;
							ACPI.FIELD.Read("_SB.PCI0.SBRG.EC0.CDT1", ref a);
							QFAN_FanSpeed.qfan_fanspeed = a;
							initialisation = true;
							return true;
						}
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion

			#region Value class for QFAN_CPUFanSpeedDesired : class QFAN_CPUFanSpeedDesired
			public static class QFAN_CPUFanSpeedDesired
			{
				public const string description = "Desired fan speed";
				public const bool nhc_visible = true;
				public static int qfan_cpufanspeeddesired = 0;
				public const string unit = "";

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 255;
					public const int nhc_default_value = 144;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion

			#region Value class for QFAN_CPUFanSpeedStep : class QFAN_CPUFanSpeedStep
			public static class QFAN_CPUFanSpeedStep
			{
				public const string description = "Fan speed step";
				public const bool nhc_visible = true;
				public static int qfan_cpufanspeedstep = 1;
				public const string unit = "";

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 1;
					public const int nhc_maximum_value = 30;
					public const int nhc_default_value = 1;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion

			public const double refresh_interval = 1;
			public static bool refresh() 
			{
				if(QFAN_CPUTemperaturePrevious.qfan_refreshdivider < 3)
				{
					QFAN_CPUTemperaturePrevious.qfan_refreshdivider++;
					return true;
				}
				QFAN_CPUTemperaturePrevious.qfan_refreshdivider = 0;
				
				int temperature_current = 0;
				int temperature_desired = 0;
				int speed_current = 0;
				int speed_previous = 0;
				int speed_desired = 0;
				int speed_step = 0;

				temperature_desired = QFAN_CPUTemperatureDesired.qfan_cputemperaturedesired;
				speed_desired = QFAN_CPUFanSpeedDesired.qfan_cpufanspeeddesired;
				speed_step = QFAN_CPUFanSpeedStep.qfan_cpufanspeedstep;
				ACPI.FIELD.Read("_TZ.THRM._TMP", ref temperature_current);
				temperature_current = (temperature_current - 2732) / 10;
				ACPI.FIELD.Read("_SB.PCI0.SBRG.EC0.CDT1", ref speed_current);

				if(QFAN_CPUTemperaturePrevious.qfan_cputemperatureprevious != -1)
				{
					if(temperature_current != temperature_desired)
					{
						if(temperature_current > temperature_desired)
						{
							if(temperature_current == QFAN_CPUTemperaturePrevious.qfan_cputemperatureprevious)
							{
								speed_previous = speed_current;
								speed_current += speed_step;
								if(speed_current > 255) speed_current = 255;								
								if(speed_current != speed_previous) QFAN_SetCPUFanSpeed(speed_current);	
							}
						}
						else
						{
							if(QFAN_CPUTemperaturePrevious.qfan_cputemperatureprevious == temperature_current)
							{
								if(speed_current > speed_desired)
								{
									speed_previous = speed_current;
									speed_current -= speed_step;
									if(speed_current < 0) speed_current = 0;
									if(speed_current != speed_previous) QFAN_SetCPUFanSpeed(speed_current);
								}
							}
				       		}
				       	}
				}
				
				QFAN_CPUTemperature.qfan_cputemperature = temperature_current;
				QFAN_FanSpeed.qfan_fanspeed = speed_current;
				QFAN_CPUTemperaturePrevious.qfan_cputemperatureprevious = temperature_current;

				return true;
			}
			
			private static bool QFAN_SetCPUFanSpeed(int speed)
			{
				ACPI.NAME.Write("_TZ.PLCY", 0);
				int a, b, c, res;
				a = 0x84;
				b = speed;
				c = 0xC4;
				res = ((a << 16) + (b << 8) + (c));
				ACPI.METHOD.SetValue("_TZ.TMSS", 0);
				ACPI.METHOD.SetValue("_SB.ATKD.ECRW", res);
				ACPI.METHOD.Call("_TZ.UMIT");
				return true;
			}
		}
		#endregion

		#region Class for Asus A8JS SFAN control : class SFAN
		public static class SFAN
		{
			public const string description = "ACPI fan automatic speed control";
			public const bool default_enable = false;
			public const int icon = 2;
			
			#region Value class for SFAN_CPUTemperature : class SFAN_CPUTemperature
			public static class SFAN_CPUTemperature
			{
				public const string description = "Current CPU temperature";
				public const bool nhc_visible = true;
				public static int sfan_cputemperature = 0;
				public const string unit = "C";
			}
			#endregion

			#region Value class for SFAN_FanSpeed : class SFAN_FanSpeed
			public static class SFAN_FanSpeed
			{
				public const string description = "Current fan speed (0 - 255)";
				public const bool nhc_visible = true;
				public static int sfan_fanspeed = 0;
				public const string unit = "";
				public static int sfan_refreshdivider = 0;
			}
			#endregion	

			#region Value class for SFAN_UpdateSpeed : class SFAN_UpdateSpeed
			public static class SFAN_UpdateSpeed
			{
				public const string description = "Update once in";
				public const bool nhc_visible = true;
				public static int sfan_updatespeed = 0;
				public const string unit = " second(s)";

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 1;
					public const int nhc_maximum_value = 20;
					public const int nhc_default_value = 6;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion

			#region Value class for SFAN_SpeedProfile1 : class SFAN_SpeedProfile1
			public static class SFAN_SpeedProfile1
			{
				public const string description = "Profile 1, the highest CPU temperature allowed";
				public const bool nhc_visible = true;
				public static int sfan_speedprofile1 = 0;
				public const string unit = "C";
				public static bool initialisation = false;

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 100;
					public const int nhc_default_value = 49;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion
			
			#region Value class for SFAN_SpeedProfile1_S : class SFAN_SpeedProfile1_S
			public static class SFAN_SpeedProfile1_S
			{
				public const string description = "Profile 1, fan speed";
				public const bool nhc_visible = true;
				public static int sfan_speedprofile1_s = 0;
				public const string unit = "";
				public static bool initialisation = false;

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 255;
					public const int nhc_default_value = 105;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion
			
			#region Value class for SFAN_SpeedProfile2 : class SFAN_SpeedProfile2
			public static class SFAN_SpeedProfile2
			{
				public const string description = "Profile 2, the highest CPU temperature allowed";
				public const bool nhc_visible = true;
				public static int sfan_speedprofile2 = 0;
				public const string unit = "C";
				public static bool initialisation = false;

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 100;
					public const int nhc_default_value = 56;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion
			
			#region Value class for SFAN_SpeedProfile2_S : class SFAN_SpeedProfile2_S
			public static class SFAN_SpeedProfile2_S
			{
				public const string description = "Profile 2, fan speed";
				public const bool nhc_visible = true;
				public static int sfan_speedprofile2_s = 0;
				public const string unit = "";
				public static bool initialisation = false;

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 255;
					public const int nhc_default_value = 144;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion
			
			#region Value class for SFAN_SpeedProfile3 : class SFAN_SpeedProfile3
			public static class SFAN_SpeedProfile3
			{
				public const string description = "Profile 3, the highest CPU temperature allowed";
				public const bool nhc_visible = true;
				public static int sfan_speedprofile3 = 0;
				public const string unit = "C";
				public static bool initialisation = false;

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 100;
					public const int nhc_default_value = 67;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion
			
			#region Value class for SFAN_SpeedProfile3_S : class SFAN_SpeedProfile3_S
			public static class SFAN_SpeedProfile3_S
			{
				public const string description = "Profile 3, fan speed";
				public const bool nhc_visible = true;
				public static int sfan_speedprofile3_s = 0;
				public const string unit = "";
				public static bool initialisation = false;

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 255;
					public const int nhc_default_value = 165;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion
			
			#region Value class for SFAN_SpeedProfile4 : class SFAN_SpeedProfile4
			public static class SFAN_SpeedProfile4
			{
				public const string description = "Profile 4, the highest CPU temperature allowed";
				public const bool nhc_visible = true;
				public static int sfan_speedprofile4 = 0;
				public const string unit = "C";
				public static bool initialisation = false;

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 100;
					public const int nhc_default_value = 70;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion
			
			#region Value class for SFAN_SpeedProfile4_S : class SFAN_SpeedProfile4_S
			public static class SFAN_SpeedProfile4_S
			{
				public const string description = "Profile 4, fan speed";
				public const bool nhc_visible = true;
				public static int sfan_speedprofile4_s = 0;
				public const string unit = "";
				public static bool initialisation = false;

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 255;
					public const int nhc_default_value = 200;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion
			
			#region Value class for SFAN_SpeedProfile5 : class SFAN_SpeedProfile5
			public static class SFAN_SpeedProfile5
			{
				public const string description = "Profile 5, the highest CPU temperature allowed";
				public const bool nhc_visible = true;
				public static int sfan_speedprofile5 = 0;
				public const string unit = "C";
				public static bool initialisation = false;

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 100;
					public const int nhc_default_value = 75;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion
			
			#region Value class for SFAN_SpeedProfile5_S : class SFAN_SpeedProfile5_S
			public static class SFAN_SpeedProfile5_S
			{
				public const string description = "Profile 5, fan speed";
				public const bool nhc_visible = true;
				public static int sfan_speedprofile5_s = 0;
				public const string unit = "";
				public static bool initialisation = false;

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 255;
					public const int nhc_default_value = 215;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion
			
			#region Value class for SFAN_SpeedProfile6 : class SFAN_SpeedProfile6
			public static class SFAN_SpeedProfile6
			{
				public const string description = "Profile 6, the highest CPU temperature allowed";
				public const bool nhc_visible = true;
				public static int sfan_speedprofile6 = 0;
				public const string unit = "C";
				public static bool initialisation = false;

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 100;
					public const int nhc_default_value = 100;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion
			
			#region Value class for SFAN_SpeedProfile6_S : class SFAN_SpeedProfile6_S
			public static class SFAN_SpeedProfile6_S
			{
				public const string description = "Profile 6, fan speed";
				public const bool nhc_visible = true;
				public static int sfan_speedprofile6_s = 0;
				public const string unit = "";
				public static bool initialisation = false;

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 255;
					public const int nhc_default_value = 255;

					public static bool nhc_on_write()
					{
						// nothing to do; value used only by timer
						return true;
					}
				}
			}
			#endregion
			
			#region Value class for SFAN_SpeedProfileDefault : class SFAN_SpeedProfileDefault
			public static class SFAN_SpeedProfileDefault
			{
				public const string description = "Default profile, fan speed";
				public const bool nhc_visible = true;
				public static int sfan_speedprofiledefault = 255;
				public const string unit = "";
				public static bool initialisation = false;				
			}
			#endregion
		
			public const double refresh_interval = 1;
			public static bool refresh() 
			{
				if(SFAN_FanSpeed.sfan_refreshdivider < SFAN_UpdateSpeed.sfan_updatespeed)
				{
					SFAN_FanSpeed.sfan_refreshdivider++;
					return true;
				}
				SFAN_FanSpeed.sfan_refreshdivider = 0;
				
				int temperature_current = 0;				
				int speed_current = 0;
								
				ACPI.FIELD.Read("_TZ.THRM._TMP", ref temperature_current);
				temperature_current = (temperature_current - 2732) / 10;
				ACPI.FIELD.Read("_SB.PCI0.SBRG.EC0.CDT1", ref speed_current);
				
				int[] t_ = new int[6];
				t_[0] = SFAN_SpeedProfile1.sfan_speedprofile1;
				t_[1] = SFAN_SpeedProfile2.sfan_speedprofile2;
				t_[2] = SFAN_SpeedProfile3.sfan_speedprofile3;
				t_[3] = SFAN_SpeedProfile4.sfan_speedprofile4;
				t_[4] = SFAN_SpeedProfile5.sfan_speedprofile5;
				t_[5] = SFAN_SpeedProfile6.sfan_speedprofile6;
				
				int[] s_ = new int[6];
				s_[0] = SFAN_SpeedProfile1_S.sfan_speedprofile1_s;				
				s_[1] = SFAN_SpeedProfile2_S.sfan_speedprofile2_s;
				s_[2] = SFAN_SpeedProfile3_S.sfan_speedprofile3_s;
				s_[3] = SFAN_SpeedProfile4_S.sfan_speedprofile4_s;
				s_[4] = SFAN_SpeedProfile5_S.sfan_speedprofile5_s;
				s_[5] = SFAN_SpeedProfile6_S.sfan_speedprofile6_s;
								
				int tmp;				
 				for(int i = 1; i < 6; i++)
    					for(int j = 5; j > 0; j--)
      						if(t_[j - 1] > t_[j])
        					{
        						tmp = t_[j];
        						t_[j] = t_[j - 1];
        						t_[j - 1] = tmp;
        						tmp = s_[j];
        						s_[j] = s_[j - 1];
        						s_[j - 1] = tmp;
        					}
        			
        			bool ok = false;
        			for(int i = 0; i < 6 ; i++)
	        			if(temperature_current <= t_[i])
	        			{
        					if(s_[i] != speed_current) SFAN_SetCPUFanSpeed(s_[i]);
        					ok = true;
        					break;
        				}
        			
        			if(!ok) SFAN_SetCPUFanSpeed(255);
					
                                SFAN_CPUTemperature.sfan_cputemperature = temperature_current;
                                SFAN_FanSpeed.sfan_fanspeed = speed_current;
                                
				return true;
			}
			
			private static bool SFAN_SetCPUFanSpeed(int speed)
			{
				ACPI.NAME.Write("_TZ.PLCY", 0);
				int a, b, c, res;
				a = 0x84;
				b = speed;
				c = 0xC4;
				res = ((a << 16) + (b << 8) + (c));
				ACPI.METHOD.SetValue("_TZ.TMSS", 0);
				ACPI.METHOD.SetValue("_SB.ATKD.ECRW", res);
				ACPI.METHOD.Call("_TZ.UMIT");
				return true;
			}
		}
		#endregion
	}
	#endregion
}